package org.eclipse.palamedes.kif.core.ast.visitor;

import org.eclipse.palamedes.kif.core.ast.ASTNode;

public class ContainsChecker extends DefaultVisitor {

    boolean  contains;
    Class<?> searchType;


    public boolean containsType(ASTNode node, Class<?> type) {
        contains   = false;
        searchType = type;
        node.traverse(this);
        return contains;
    }

    @Override
    public void preVisitComplexNode(ASTNode node) {
        contains |= searchType.equals( node.getClass() );
    }

    @Override
    public void visitBasicNode(ASTNode node) {
        contains |= searchType.equals( node.getClass() );
    }

}
