package org.eclipse.palamedes.kif.core.knowledgebase.filter;

import java.util.ArrayList;

import org.eclipse.palamedes.kif.core.knowledgebase.IKBFilter;
import org.eclipse.palamedes.kif.core.knowledgebase.KBEntry;


public class OrFilter extends ArrayList<IKBFilter> implements IKBFilter {

    public boolean isMatching(KBEntry entry) {
        boolean match = true;

        for (IKBFilter filter : this) {
            match |= filter.isMatching(entry);
            if (!match)
                return false;
        }
        return true;
    }

}
